Subject: ‘Internal compiler error: Segmentationfault’ when building aarch64-linux-gnu cross-compiler [core-updates]

From: Maxime Devos <[email-masked]>
Date: Mon, 05 Jul 2021 13:52:53 +0200

Hi guix,

While testing a patch re-introducing %build-inputs when cross-compiling
(probably irrelevant to the build failure though), I encountered an ICE
(internal compiler error).  I checked 'dmesg'; it is not an OOM.
I believe I encountered similar errors in the past, though they disappeared
when I retried the build, so this looks like a non-determenistic build
failure.

Greetings,
Maxime

g++ -fno-PIE -c   -g -O2 -DIN_GCC  -DCROSS_DIRECTORY_STRUCTURE   -fno-exceptions -fno-rtti -fasynchronous-unwind-tables -W -Wall -Wno-narrowing -Wwrite-strings -Wcast-qual -Wno-error=format-diag
-Wmissing-format-attribute -Woverloaded-virtual -pedantic -Wno-long-long -Wno-variadic-macros -Wno-overlength-strings   -DHAVE_CONFIG_H -I. -I. -I../../gcc-10.3.0/gcc -I../../gcc-10.3.0/gcc/.
-I../../gcc-10.3.0/gcc/../include -I../../gcc-10.3.0/gcc/../libcpp/include  -I../../gcc-10.3.0/gcc/../libdecnumber -I../../gcc-10.3.0/gcc/../libdecnumber/dpd -I../libdecnumber -I../../gcc-
10.3.0/gcc/../libbacktrace   -o tree-ssa-strlen.o -MT tree-ssa-strlen.o -MMD -MP -MF ./.deps/tree-ssa-strlen.TPo ../../gcc-10.3.0/gcc/tree-ssa-strlen.c
g++ -fno-PIE -c   -g -O2 -DIN_GCC  -DCROSS_DIRECTORY_STRUCTURE   -fno-exceptions -fno-rtti -fasynchronous-unwind-tables -W -Wall -Wno-narrowing -Wwrite-strings -Wcast-qual -Wno-error=format-diag
-Wmissing-format-attribute -Woverloaded-virtual -pedantic -Wno-long-long -Wno-variadic-macros -Wno-overlength-strings   -DHAVE_CONFIG_H -I. -I. -I../../gcc-10.3.0/gcc -I../../gcc-10.3.0/gcc/.
-I../../gcc-10.3.0/gcc/../include -I../../gcc-10.3.0/gcc/../libcpp/include  -I../../gcc-10.3.0/gcc/../libdecnumber -I../../gcc-10.3.0/gcc/../libdecnumber/dpd -I../libdecnumber -I../../gcc-
10.3.0/gcc/../libbacktrace   -o tree-ssa-structalias.o -MT tree-ssa-structalias.o -MMD -MP -MF ./.deps/tree-ssa-structalias.TPo ../../gcc-10.3.0/gcc/tree-ssa-structalias.c
during RTL pass: vartrack
../../gcc-10.3.0/gcc/tree-ssa-strlen.c: In function ‘void maybe_warn_overflow(gimple*, tree, const vr_values*, strinfo*, bool, bool)’:
../../gcc-10.3.0/gcc/tree-ssa-strlen.c:2336:1: internal compiler error: Segmentation fault
 2336 | }
      | ^
Please submit a full bug report,
with preprocessed source if appropriate.
See <https://gcc.gnu.org/bugs/> for instructions.
make[2]: *** [Makefile:1117: tree-ssa-strlen.o] Error 1
make[2]: *** Waiting for unfinished jobs....
make[2]: Leaving directory '/tmp/guix-build-gcc-cross-sans-libc-aarch64-linux-gnu-10.3.0.drv-0/build/gcc'
make[1]: *** [Makefile:4372: all-gcc] Error 2
make[1]: Leaving directory '/tmp/guix-build-gcc-cross-sans-libc-aarch64-linux-gnu-10.3.0.drv-0/build'
make: *** [Makefile:939: all] Error 2
error: in phase 'build': uncaught exception:
%exception #<&invoke-error program: "make" arguments: ("-j" "4" "CFLAGS=-g0 -O2") exit-status: 2 term-signal: #f stop-signal: #f> 
phase `build' failed after 644.1 seconds
command "make" "-j" "4" "CFLAGS=-g0 -O2" failed with status 2
builder for `/gnu/store/j7qm4fhxbm85jg0nzhqm0h0bfc8gdlkx-gcc-cross-sans-libc-aarch64-linux-gnu-10.3.0.drv' failed with exit code 1
build of /gnu/store/j7qm4fhxbm85jg0nzhqm0h0bfc8gdlkx-gcc-cross-sans-libc-aarch64-linux-gnu-10.3.0.drv failed
View build log at '/var/log/guix/drvs/j7/qm4fhxbm85jg0nzhqm0h0bfc8gdlkx-gcc-cross-sans-libc-aarch64-linux-gnu-10.3.0.drv.bz2'.
cannot build derivation `/gnu/store/96m9gb9dsxd6adpgfyds86ndnxhf2rw9-glibc-cross-aarch64-linux-gnu-2.33.drv': 1 dependencies couldn't be built
building /gnu/store/5n3y8gy3w924xm5zv1v65fz7lga8hs2d-pkg-config-aarch64-linux-gnu-0.29.2.drv...
cannot build derivation `/gnu/store/nzb1jx1xvp4vsh9qgbq455m1fvnj2vsn-grep-3.6.drv': 1 dependencies couldn't be built
guix build: error: build of `/gnu/store/nzb1jx1xvp4vsh9qgbq455m1fvnj2vsn-grep-3.6.drv' failed